# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictStr
from pydantic import Field
from typing_extensions import Annotated
from yandex_api_client.models.campaign_settings_time_period_dto import CampaignSettingsTimePeriodDTO
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class CampaignSettingsScheduleDTO(BaseModel):
    """
    Расписание работы службы доставки в своем регионе.
    """ # noqa: E501
    available_on_holidays: Optional[StrictBool] = Field(default=None, description="Признак работы службы доставки в государственные праздники. Возможные значения. * `false` — служба доставки не работает в праздничные дни. * `true` — служба доставки работает в праздничные дни. ", alias="availableOnHolidays")
    custom_holidays: Optional[List[StrictStr]] = Field(default=None, description="Список дней, в которые служба доставки не работает. Дни магазин указал в личном кабинете на Маркете.", alias="customHolidays")
    custom_working_days: Optional[List[StrictStr]] = Field(default=None, description="Список выходных и праздничных дней, в которые служба доставки работает. Дни магазин указал в личном кабинете на Маркете.", alias="customWorkingDays")
    period: Optional[CampaignSettingsTimePeriodDTO] = None
    total_holidays: Optional[List[StrictStr]] = Field(default=None, description="Итоговый список нерабочих дней службы доставки. Список рассчитывается с учетом выходных, нерабочих дней и государственных праздников. Информацию по ним магазин указывает в личном кабинете на Маркете.", alias="totalHolidays")
    weekly_holidays: Optional[List[Annotated[int, Field(le=7, strict=True, ge=1)]]] = Field(default=None, description="Список выходных дней недели и государственных праздников.", alias="weeklyHolidays")
    __properties: ClassVar[List[str]] = ["availableOnHolidays", "customHolidays", "customWorkingDays", "period", "totalHolidays", "weeklyHolidays"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CampaignSettingsScheduleDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of period
        if self.period:
            _dict['period'] = self.period.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of CampaignSettingsScheduleDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "availableOnHolidays": obj.get("availableOnHolidays"),
            "customHolidays": obj.get("customHolidays"),
            "customWorkingDays": obj.get("customWorkingDays"),
            "period": CampaignSettingsTimePeriodDTO.from_dict(obj.get("period")) if obj.get("period") is not None else None,
            "totalHolidays": obj.get("totalHolidays"),
            "weeklyHolidays": obj.get("weeklyHolidays")
        })
        return _obj


