# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt
from pydantic import Field
from yandex_api_client.models.feed_content_error_dto import FeedContentErrorDTO
from yandex_api_client.models.feed_status_type import FeedStatusType
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class FeedContentDTO(BaseModel):
    """
    Информация о проверке содержимого прайс-листа, загруженного на Маркет.
    """ # noqa: E501
    rejected_offers_count: Optional[StrictInt] = Field(default=None, description="Количество предложений, в которых найдены ошибки на этапе загрузки прайс-листа. Выводится, если параметр `content status=OK`. ", alias="rejectedOffersCount")
    status: Optional[FeedStatusType] = None
    total_offers_count: Optional[StrictInt] = Field(default=None, description="Количество предложений в прайс-листе. Выводится, если параметр `content status=OK`. ", alias="totalOffersCount")
    error: Optional[FeedContentErrorDTO] = None
    __properties: ClassVar[List[str]] = ["rejectedOffersCount", "status", "totalOffersCount", "error"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of FeedContentDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of error
        if self.error:
            _dict['error'] = self.error.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of FeedContentDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "rejectedOffersCount": obj.get("rejectedOffersCount"),
            "status": obj.get("status"),
            "totalOffersCount": obj.get("totalOffersCount"),
            "error": FeedContentErrorDTO.from_dict(obj.get("error")) if obj.get("error") is not None else None
        })
        return _obj


