# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt
from pydantic import Field
from typing_extensions import Annotated
from yandex_api_client.models.brief_order_item_instance_dto import BriefOrderItemInstanceDTO
from yandex_api_client.models.order_box_layout_partial_count_dto import OrderBoxLayoutPartialCountDTO
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class OrderBoxLayoutItemDTO(BaseModel):
    """
    Информация о товаре в коробке.
    """ # noqa: E501
    id: StrictInt = Field(description="Идентификатор товара в заказе.  {% cut \"Где его взять\" %}  Идентификатор приходит в ответе на запрос [GET campaigns/{campaignId}/orders/{orderId}](../../reference/orders/getOrder.md) и в запросе Маркета [POST order/accept](../../pushapi/reference/orderAccept.md) — параметр `id` в `items`.  {% endcut %}   ")
    full_count: Optional[Annotated[int, Field(strict=True, ge=1)]] = Field(default=None, description="Количество единиц товара в коробке.  Используйте это поле, если в коробке поедут целые товары, не разделенные на части. Не используйте это поле одновременно с `partialCount`. ", alias="fullCount")
    partial_count: Optional[OrderBoxLayoutPartialCountDTO] = Field(default=None, alias="partialCount")
    instances: Optional[List[BriefOrderItemInstanceDTO]] = Field(default=None, description="Переданные вами коды маркировки.")
    __properties: ClassVar[List[str]] = ["id", "fullCount", "partialCount", "instances"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of OrderBoxLayoutItemDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of partial_count
        if self.partial_count:
            _dict['partialCount'] = self.partial_count.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in instances (list)
        _items = []
        if self.instances:
            for _item in self.instances:
                if _item:
                    _items.append(_item.to_dict())
            _dict['instances'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of OrderBoxLayoutItemDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "fullCount": obj.get("fullCount"),
            "partialCount": OrderBoxLayoutPartialCountDTO.from_dict(obj.get("partialCount")) if obj.get("partialCount") is not None else None,
            "instances": [BriefOrderItemInstanceDTO.from_dict(_item) for _item in obj.get("instances")] if obj.get("instances") is not None else None
        })
        return _obj


