# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field
from yandex_api_client.models.parcel_box_label_dto import ParcelBoxLabelDTO
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class OrderLabelDTO(BaseModel):
    """
    Данные для печати ярлыка.
    """ # noqa: E501
    order_id: StrictInt = Field(description="Идентификатор заказа.", alias="orderId")
    places_number: StrictInt = Field(description="Количество коробок в заказе.", alias="placesNumber")
    url: StrictStr = Field(description="URL файла с ярлыками‑наклейками на все коробки в заказе.  Соответствует URL, по которому выполняется запрос [GET campaigns/{campaignId}/orders/{orderId}/delivery/labels](../../reference/orders/generateOrderLabels.md). ")
    parcel_box_labels: List[ParcelBoxLabelDTO] = Field(description="Информация на ярлыке.", alias="parcelBoxLabels")
    __properties: ClassVar[List[str]] = ["orderId", "placesNumber", "url", "parcelBoxLabels"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of OrderLabelDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in parcel_box_labels (list)
        _items = []
        if self.parcel_box_labels:
            for _item in self.parcel_box_labels:
                if _item:
                    _items.append(_item.to_dict())
            _dict['parcelBoxLabels'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of OrderLabelDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "orderId": obj.get("orderId"),
            "placesNumber": obj.get("placesNumber"),
            "url": obj.get("url"),
            "parcelBoxLabels": [ParcelBoxLabelDTO.from_dict(_item) for _item in obj.get("parcelBoxLabels")] if obj.get("parcelBoxLabels") is not None else None
        })
        return _obj


