# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt
from pydantic import Field
from yandex_api_client.models.orders_stats_item_status_type import OrdersStatsItemStatusType
from yandex_api_client.models.orders_stats_stock_type import OrdersStatsStockType
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class OrdersStatsDetailsDTO(BaseModel):
    """
    Информация об удалении товара из заказа.
    """ # noqa: E501
    item_status: Optional[OrdersStatsItemStatusType] = Field(default=None, alias="itemStatus")
    item_count: Optional[StrictInt] = Field(default=None, description="Количество товара со статусом, указанном в параметре `itemStatus`.", alias="itemCount")
    update_date: Optional[date] = Field(default=None, description="Дата, когда товар получил статус, указанный в параметре `itemStatus`.  Формат даты: `ГГГГ-ММ-ДД`. ", alias="updateDate")
    stock_type: Optional[OrdersStatsStockType] = Field(default=None, alias="stockType")
    __properties: ClassVar[List[str]] = ["itemStatus", "itemCount", "updateDate", "stockType"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of OrdersStatsDetailsDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of OrdersStatsDetailsDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "itemStatus": obj.get("itemStatus"),
            "itemCount": obj.get("itemCount"),
            "updateDate": obj.get("updateDate"),
            "stockType": obj.get("stockType")
        })
        return _obj


