# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
import re  # noqa: F401
from enum import Enum



try:
    from typing import Self
except ImportError:
    from typing_extensions import Self


class PriceSuggestType(str, Enum):
    """
    Тип цены:  * `BUYBOX` — самая низкая цена на товар, по которой он продается сейчас. Эта цена обновляется в режиме реального времени. Если вы установите цену ниже, начнет показываться ваше предложение. Если для этого значения в параметре `price` указана цена, которая совпадает с вашей, значит, ваш товар уже показывается на витрине. Если кроме вас этот товар продают другие продавцы по такой же цене, их предложения также будут отображаться вместе с вашими по очереди. * `DEFAULT_OFFER` — рекомендованная Маркетом цена, которая привлекает покупателей. Рассчитывается только для популярных на сервисе товаров и обновляется раз в четыре часа. * `MIN_PRICE_MARKET` — минимальная цена на Маркете. Самая низкая цена среди всех предложений товара на Маркете во всех регионах, включая те, которые не видны на витрине. Эта цена обновляется в режиме реального времени и обеспечивает большее количество показов на Маркете, чем самая низкая или рекомендованная цена. * `MAX_DISCOUNT_BASE` — максимальная цена товара без скидки (старая цена), при которой он может быть показан со скидкой. Данная цена рассчитывается автоматически на основе SKU на Яндексе.  {% note info %}  Если цена типа `MAX_DISCOUNT_BASE` не возвращается, скидка на товар не будет показана, так как для него еще не накопилась история цен.  {% endnote %}  * `MARKET_OUTLIER_PRICE` — максимальная цена товара, которая обеспечивает показы на Маркете. Если ваша цена выше указанной, товар будет скрыт, так как цена превышает рекомендованную Маркетом на 40% или больше. * `MAX_DISCOUNT_PRICE` — максимальная цена товара после применения скидки, при которой он будет показан на Маркете со скидкой. 
    """

    """
    allowed enum values
    """
    BUYBOX = 'BUYBOX'
    DEFAULT_OFFER = 'DEFAULT_OFFER'
    MIN_PRICE_MARKET = 'MIN_PRICE_MARKET'
    MAX_DISCOUNT_BASE = 'MAX_DISCOUNT_BASE'
    MARKET_OUTLIER_PRICE = 'MARKET_OUTLIER_PRICE'
    MAX_DISCOUNT_PRICE = 'MAX_DISCOUNT_PRICE'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PriceSuggestType from a JSON string"""
        return cls(json.loads(json_str))


