# coding: utf-8

"""
    Партнерский API Маркета

    API Яндекс Маркета помогает продавцам автоматизировать и упростить работу с маркетплейсом.  В числе возможностей интеграции:  * управление каталогом товаров и витриной,  * обработка заказов,  * изменение настроек магазина,  * получение отчетов. 

    The version of the OpenAPI document: LATEST
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt
from pydantic import Field
from yandex_api_client.models.delivery_service_dto import DeliveryServiceDTO
from yandex_api_client.models.pallets_count_dto import PalletsCountDTO
from yandex_api_client.models.partner_shipment_warehouse_dto import PartnerShipmentWarehouseDTO
from yandex_api_client.models.shipment_action_type import ShipmentActionType
from yandex_api_client.models.shipment_status_change_dto import ShipmentStatusChangeDTO
from yandex_api_client.models.shipment_type import ShipmentType
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ShipmentDTO(BaseModel):
    """
    Информация об отгрузке.
    """ # noqa: E501
    id: Optional[StrictInt] = Field(default=None, description="Идентификатор отгрузки.")
    plan_interval_from: Optional[datetime] = Field(default=None, description="Начало планового интервала отгрузки.", alias="planIntervalFrom")
    plan_interval_to: Optional[datetime] = Field(default=None, description="Конец планового интервала отгрузки.", alias="planIntervalTo")
    shipment_type: Optional[ShipmentType] = Field(default=None, alias="shipmentType")
    warehouse: Optional[PartnerShipmentWarehouseDTO] = None
    warehouse_to: Optional[PartnerShipmentWarehouseDTO] = Field(default=None, alias="warehouseTo")
    delivery_service: Optional[DeliveryServiceDTO] = Field(default=None, alias="deliveryService")
    pallets_count: Optional[PalletsCountDTO] = Field(default=None, alias="palletsCount")
    current_status: Optional[ShipmentStatusChangeDTO] = Field(default=None, alias="currentStatus")
    order_ids: Optional[List[StrictInt]] = Field(default=None, description="Идентификаторы заказов в отгрузке.", alias="orderIds")
    available_actions: Optional[List[ShipmentActionType]] = Field(default=None, description="Доступные действия над отгрузкой.", alias="availableActions")
    __properties: ClassVar[List[str]] = ["id", "planIntervalFrom", "planIntervalTo", "shipmentType", "warehouse", "warehouseTo", "deliveryService", "palletsCount", "currentStatus", "orderIds", "availableActions"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ShipmentDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of warehouse
        if self.warehouse:
            _dict['warehouse'] = self.warehouse.to_dict()
        # override the default output from pydantic by calling `to_dict()` of warehouse_to
        if self.warehouse_to:
            _dict['warehouseTo'] = self.warehouse_to.to_dict()
        # override the default output from pydantic by calling `to_dict()` of delivery_service
        if self.delivery_service:
            _dict['deliveryService'] = self.delivery_service.to_dict()
        # override the default output from pydantic by calling `to_dict()` of pallets_count
        if self.pallets_count:
            _dict['palletsCount'] = self.pallets_count.to_dict()
        # override the default output from pydantic by calling `to_dict()` of current_status
        if self.current_status:
            _dict['currentStatus'] = self.current_status.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ShipmentDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "planIntervalFrom": obj.get("planIntervalFrom"),
            "planIntervalTo": obj.get("planIntervalTo"),
            "shipmentType": obj.get("shipmentType"),
            "warehouse": PartnerShipmentWarehouseDTO.from_dict(obj.get("warehouse")) if obj.get("warehouse") is not None else None,
            "warehouseTo": PartnerShipmentWarehouseDTO.from_dict(obj.get("warehouseTo")) if obj.get("warehouseTo") is not None else None,
            "deliveryService": DeliveryServiceDTO.from_dict(obj.get("deliveryService")) if obj.get("deliveryService") is not None else None,
            "palletsCount": PalletsCountDTO.from_dict(obj.get("palletsCount")) if obj.get("palletsCount") is not None else None,
            "currentStatus": ShipmentStatusChangeDTO.from_dict(obj.get("currentStatus")) if obj.get("currentStatus") is not None else None,
            "orderIds": obj.get("orderIds"),
            "availableActions": obj.get("availableActions")
        })
        return _obj


